#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include "timer.h"

struct timeval start;
struct timeval now;
struct timeval elapsed;

void startTimer()
{
  #ifndef __WIN32__
    gettimeofday(&start, NULL);
  #endif
}

struct timeval * peekTimer()
{
  #ifndef __WIN32
    gettimeofday(&now, NULL);
    elapsed.tv_sec = now.tv_sec - start.tv_sec;
    elapsed.tv_usec = now.tv_usec - start.tv_usec;

    if (elapsed.tv_usec < 0)
    { /* for cases like 1.15s - 0.45s = 0.30s where us2 > us1 */
      elapsed.tv_sec--;
      elapsed.tv_usec = (1000000 - start.tv_usec) + now.tv_usec;
    }
  #endif
  return &elapsed;
}

void stopTimer()
{
  peekTimer();
}

void showElapsedTime()
{
  printf("Elapsed time: %ld.%.6lds\n", elapsed.tv_sec, elapsed.tv_usec);
}
